<?php

namespace Emagicone\Connector\Helper;

class GlobalConstants
{
    const XML_PATH_EMAGICONE_CONNECTOR = 'emagicone_connector';
    const CONFIG_PATHS = [
        self::XML_PATH_EMAGICONE_CONNECTOR . '/access/enable',
        self::XML_PATH_EMAGICONE_CONNECTOR . '/access/login',
        self::XML_PATH_EMAGICONE_CONNECTOR . '/access/password',
        self::XML_PATH_EMAGICONE_CONNECTOR . '/settings/package_size',
        self::XML_PATH_EMAGICONE_CONNECTOR . '/settings/excluded_tables',
        self::XML_PATH_EMAGICONE_CONNECTOR . '/settings/required_tables',
    ];
    const SM_TABLES_REGEXP = '/sm_.+/';
    const REQUIRED_TABLES_REGEXP = [
        'catalog_category_flat_store_.+',
        'catalog_category_product_index_store.+',
        'catalog_product_flat_.+',
        'catalogsearch_fulltext_scope.+',
        'inventory_stock_.+',
        'sequence_creditmemo_.+',
        'sequence_invoice_.+',
        'sequence_order_.+',
        'sequence_shipment_.+',
        'sequence_rma_item_.+'
    ];
    const REQUIRED_TABLES = [
        'admin_analytics_usage_version_log',
        'admin_passwords',
        'admin_system_messages',
        'admin_user',
        'admin_user_session',
        'adminnotification_inbox',
        'authorization_role',
        'authorization_rule',
        'catalog_category_entity',
        'catalog_category_entity_datetime',
        'catalog_category_entity_decimal',
        'catalog_category_entity_int',
        'catalog_category_entity_text',
        'catalog_category_entity_varchar',
        'catalog_category_product',
        'catalog_category_product_index',
        'catalog_category_product_index_replica',
        'catalog_category_product_index_tmp',
        'catalog_compare_item',
        'catalog_eav_attribute',
        'catalog_product_bundle_option',
        'catalog_product_bundle_option_value',
        'catalog_product_bundle_price_index',
        'catalog_product_bundle_selection',
        'catalog_product_bundle_selection_price',
        'catalog_product_bundle_stock_index',
        'catalog_product_entity',
        'catalog_product_entity_datetime',
        'catalog_product_entity_decimal',
        'catalog_product_entity_gallery',
        'catalog_product_entity_int',
        'catalog_product_entity_media_gallery',
        'catalog_product_entity_media_gallery_value',
        'catalog_product_entity_media_gallery_value_to_entity',
        'catalog_product_entity_media_gallery_value_video',
        'catalog_product_entity_text',
        'catalog_product_entity_tier_price',
        'catalog_product_entity_varchar',
        'catalog_product_frontend_action',
        'catalog_product_index_eav',
        'catalog_product_index_eav_decimal',
        'catalog_product_index_eav_decimal_idx',
        'catalog_product_index_eav_decimal_replica',
        'catalog_product_index_eav_decimal_tmp',
        'catalog_product_index_eav_idx',
        'catalog_product_index_eav_replica',
        'catalog_product_index_eav_tmp',
        'catalog_product_index_price',
        'catalog_product_index_price_bundle_idx',
        'catalog_product_index_price_bundle_opt_idx',
        'catalog_product_index_price_bundle_opt_tmp',
        'catalog_product_index_price_bundle_sel_idx',
        'catalog_product_index_price_bundle_sel_tmp',
        'catalog_product_index_price_bundle_tmp',
        'catalog_product_index_price_cfg_opt_agr_idx',
        'catalog_product_index_price_cfg_opt_agr_tmp',
        'catalog_product_index_price_cfg_opt_idx',
        'catalog_product_index_price_cfg_opt_tmp',
        'catalog_product_index_price_downlod_idx',
        'catalog_product_index_price_downlod_tmp',
        'catalog_product_index_price_final_idx',
        'catalog_product_index_price_final_tmp',
        'catalog_product_index_price_idx',
        'catalog_product_index_price_opt_agr_idx',
        'catalog_product_index_price_opt_agr_tmp',
        'catalog_product_index_price_opt_idx',
        'catalog_product_index_price_opt_tmp',
        'catalog_product_index_price_replica',
        'catalog_product_index_price_tmp',
        'catalog_product_index_tier_price',
        'catalog_product_index_website',
        'catalog_product_link',
        'catalog_product_link_attribute',
        'catalog_product_link_attribute_decimal',
        'catalog_product_link_attribute_int',
        'catalog_product_link_attribute_varchar',
        'catalog_product_link_type',
        'catalog_product_option',
        'catalog_product_option_price',
        'catalog_product_option_title',
        'catalog_product_option_type_price',
        'catalog_product_option_type_title',
        'catalog_product_option_type_value',
        'catalog_product_relation',
        'catalog_product_super_attribute',
        'catalog_product_super_attribute_label',
        'catalog_product_super_link',
        'catalog_product_website',
        'catalog_url_rewrite_product_category',
        'cataloginventory_stock',
        'cataloginventory_stock_item',
        'cataloginventory_stock_status',
        'cataloginventory_stock_status_idx',
        'cataloginventory_stock_status_replica',
        'cataloginventory_stock_status_tmp',
        'catalogrule',
        'catalogrule_customer_group',
        'catalogrule_group_website',
        'catalogrule_group_website_replica',
        'catalogrule_product',
        'catalogrule_product_price',
        'catalogrule_product_price_replica',
        'catalogrule_product_replica',
        'catalogrule_website',
        'cms_block',
        'cms_block_store',
        'cms_page',
        'cms_page_store',
        'core_config_data',
        'customer_address_entity',
        'customer_address_entity_datetime',
        'customer_address_entity_decimal',
        'customer_address_entity_int',
        'customer_address_entity_text',
        'customer_address_entity_varchar',
        'customer_eav_attribute',
        'customer_eav_attribute_website',
        'customer_entity',
        'customer_entity_datetime',
        'customer_entity_decimal',
        'customer_entity_int',
        'customer_entity_text',
        'customer_entity_varchar',
        'customer_form_attribute',
        'customer_grid_flat',
        'customer_group',
        'customer_log',
        'customer_visitor',
        'directory_city_township',
        'directory_city_township_name',
        'directory_country',
        'directory_country_format',
        'directory_country_region',
        'directory_country_region_name',
        'directory_currency_rate',
        'directory_region_city',
        'directory_region_city_name',
        'downloadable_link',
        'downloadable_link_price',
        'downloadable_link_purchased',
        'downloadable_link_purchased_item',
        'downloadable_link_title',
        'downloadable_sample',
        'downloadable_sample_title',
        'eav_attribute',
        'eav_attribute_group',
        'eav_attribute_label',
        'eav_attribute_option',
        'eav_attribute_option_swatch',
        'eav_attribute_option_value',
        'eav_attribute_set',
        'eav_entity',
        'eav_entity_attribute',
        'eav_entity_datetime',
        'eav_entity_decimal',
        'eav_entity_int',
        'eav_entity_store',
        'eav_entity_text',
        'eav_entity_type',
        'eav_entity_varchar',
        'eav_form_element',
        'eav_form_fieldset',
        'eav_form_fieldset_label',
        'eav_form_type',
        'eav_form_type_entity',
        'email_abandoned_cart',
        'email_automation',
        'email_campaign',
        'email_catalog',
        'email_contact',
        'email_contact_consent',
        'email_failed_auth',
        'email_importer',
        'email_order',
        'email_review',
        'email_rules',
        'email_template',
        'email_wishlist',
        'flag',
        'gift_message',
        'inventory_geoname',
        'inventory_low_stock_notification_configuration',
        'inventory_reservation',
        'inventory_shipment_source',
        'inventory_source',
        'inventory_source_carrier_link',
        'inventory_source_item',
        'inventory_source_stock_link',
        'inventory_stock',
        'inventory_stock_sales_channel',
        'magento_acknowledged_bulk',
        'magento_bulk',
        'magento_operation',
        'newsletter_problem',
        'newsletter_queue',
        'newsletter_queue_link',
        'newsletter_queue_store_link',
        'newsletter_subscriber',
        'newsletter_template',
        'product_alert_price',
        'product_alert_stock',
        'quote',
        'quote_address',
        'quote_address_item',
        'quote_id_mask',
        'quote_item',
        'quote_item_option',
        'quote_payment',
        'quote_shipping_rate',
        'rating',
        'rating_entity',
        'rating_option',
        'rating_option_vote',
        'rating_option_vote_aggregated',
        'rating_store',
        'rating_title',
        'report_event',
        'report_event_types',
        'review',
        'review_detail',
        'review_entity',
        'review_entity_summary',
        'review_status',
        'review_store',
        'sales_bestsellers_aggregated_daily',
        'sales_bestsellers_aggregated_monthly',
        'sales_bestsellers_aggregated_yearly',
        'sales_creditmemo',
        'sales_creditmemo_comment',
        'sales_creditmemo_grid',
        'sales_creditmemo_item',
        'sales_invoice',
        'sales_invoice_comment',
        'sales_invoice_grid',
        'sales_invoice_item',
        'sales_invoiced_aggregated',
        'sales_invoiced_aggregated_order',
        'sales_order',
        'sales_order_address',
        'sales_order_aggregated_created',
        'sales_order_aggregated_updated',
        'sales_order_grid',
        'sales_order_item',
        'sales_order_payment',
        'sales_order_status',
        'sales_order_status_history',
        'sales_order_status_label',
        'sales_order_status_state',
        'sales_order_tax',
        'sales_order_tax_item',
        'sales_payment_transaction',
        'sales_refunded_aggregated',
        'sales_refunded_aggregated_order',
        'sales_sequence_meta',
        'sales_sequence_profile',
        'sales_shipment',
        'sales_shipment_comment',
        'sales_shipment_grid',
        'sales_shipment_item',
        'sales_shipment_track',
        'sales_shipping_aggregated',
        'sales_shipping_aggregated_order',
        'salesrule',
        'salesrule_coupon',
        'salesrule_coupon_aggregated',
        'salesrule_coupon_aggregated_order',
        'salesrule_coupon_aggregated_updated',
        'salesrule_coupon_usage',
        'salesrule_customer',
        'salesrule_customer_group',
        'salesrule_label',
        'salesrule_product_attribute',
        'salesrule_website',
        'setup_module',
        'sitemap',
        'store',
        'store_group',
        'store_website',
        'tax_calculation',
        'tax_calculation_rate',
        'tax_calculation_rate_title',
        'tax_calculation_rule',
        'tax_class',
        'tax_order_aggregated_created',
        'tax_order_aggregated_updated',
        'translation',
        'url_rewrite',
        'weee_tax',
        'wishlist',
        'wishlist_item',
        'wishlist_item_option',
        // Enterprise Edition tables
        'magento_banner',
        'magento_banner_catalogrule',
        'magento_banner_content',
        'magento_banner_customersegment',
        'magento_banner_salesrule',
        'magento_catalogevent_event',
        'magento_catalogevent_event_image',
        'magento_catalogpermissions',
        'magento_catalogpermissions_index',
        'magento_catalogpermissions_index_product',
        'magento_catalogpermissions_index_product_replica',
        'magento_catalogpermissions_index_product_tmp',
        'magento_catalogpermissions_index_replica',
        'magento_catalogpermissions_index_tmp',
        'magento_customerbalance',
        'magento_customerbalance_history',
        'magento_customercustomattributes_sales_flat_order',
        'magento_customercustomattributes_sales_flat_order_address',
        'magento_customercustomattributes_sales_flat_quote',
        'magento_customercustomattributes_sales_flat_quote_address',
        'magento_customersegment_customer',
        'magento_customersegment_event',
        'magento_customersegment_segment',
        'magento_customersegment_website',
        'magento_giftcard_amount',
        'magento_giftcardaccount',
        'magento_giftcardaccount_history',
        'magento_giftcardaccount_pool',
        'magento_giftregistry_data',
        'magento_giftregistry_entity',
        'magento_giftregistry_item',
        'magento_giftregistry_item_option',
        'magento_giftregistry_label',
        'magento_giftregistry_person',
        'magento_giftregistry_type',
        'magento_giftregistry_type_info',
        'magento_giftwrapping',
        'magento_giftwrapping_store_attributes',
        'magento_giftwrapping_website',
        'magento_invitation',
        'magento_invitation_status_history',
        'magento_invitation_track',
        'magento_logging_event',
        'magento_logging_event_changes',
        'magento_reminder_rule',
        'magento_reminder_rule_coupon',
        'magento_reminder_rule_log',
        'magento_reminder_rule_website',
        'magento_reminder_template',
        'magento_reward',
        'magento_reward_history',
        'magento_reward_rate',
        'magento_reward_salesrule',
        'magento_rma',
        'magento_rma_grid',
        'magento_rma_item_eav_attribute',
        'magento_rma_item_eav_attribute_website',
        'magento_rma_item_entity',
        'magento_rma_item_entity_datetime',
        'magento_rma_item_entity_decimal',
        'magento_rma_item_entity_int',
        'magento_rma_item_entity_text',
        'magento_rma_item_entity_varchar',
        'magento_rma_item_form_attribute',
        'magento_rma_shipping_label',
        'magento_rma_status_history',
        'magento_sales_creditmemo_grid_archive',
        'magento_sales_invoice_grid_archive',
        'magento_sales_order_grid_archive',
        'magento_sales_shipment_grid_archive',
        'magento_scheduled_operations',
        'magento_targetrule',
        'magento_targetrule_customersegment',
        'magento_targetrule_index',
        'magento_targetrule_index_crosssell',
        'magento_targetrule_index_crosssell_product',
        'magento_targetrule_index_related',
        'magento_targetrule_index_related_product',
        'magento_targetrule_index_upsell',
        'magento_targetrule_index_upsell_product',
        'magento_targetrule_product',
        'magento_versionscms_hierarchy_lock',
        'magento_versionscms_hierarchy_metadata',
        'magento_versionscms_hierarchy_node',
        'magento_versionscms_increment',
        'quote_preview',
        'sequence_catalog_category',
        'sequence_catalogrule',
        'sequence_cms_block',
        'sequence_cms_page',
        'sequence_product',
        'sequence_product_bundle_option',
        'sequence_product_bundle_selection',
        'sequence_salesrule',
        'staging_update',
        'variable',
        'variable_value'
    ];
}
